## org.apache.tools.ant.taskdefs.optional.perforce
Class P4Add

    java.lang.Object
      org.apache.tools.ant.ProjectComponent
          org.apache.tools.ant.Task
              org.apache.tools.ant.taskdefs.optional.perforce.P4Base
                  org.apache.tools.ant.taskdefs.optional.perforce.P4Add

All Implemented Interfaces:
  java.lang.Cloneable

    public class P4Add

extends P4Base

Adds specified files to Perforce. Example Usage:

Function | Command
--- | ---
Add files using P4USER, P4PORT and P4CLIENT settings specified | <P4add P4view="//projects/foo/main/source/..." P4User="fbloggs" P4Port="km01:1666" P4Client="fbloggsclient"> <fileset basedir="dir" includes="**/*.java"> </p4add>
Add files using P4USER, P4PORT and P4CLIENT settings defined in environment | <P4add P4view="//projects/foo/main/source/..." /> <fileset basedir="dir" includes="**/*.java"> </p4add>
Specify the length of command line arguments to pass to each invocation of p4 | <p4add Commandlength="450">

Field Summary

Fields inherited from class org.apache.tools.ant.taskdefs.optional.perforce.P4Base
`failOnError, P4Client, P4CmdOpts, P4Opts, P4Port, P4User, P4View, shell, util`

Fields inherited from class org.apache.tools.ant.Task
`target, taskName, taskType, wrapper`

Fields inherited from class org.apache.tools.ant.ProjectComponent
`description, location, project`

Constructor Summary
`P4Add()`

Method Summary
`void` `addFileset(FileSet set)` Add a fileset whose files will be added to Perforce.
`void` `execute()` Run the task.
`void` `setChangelist(int changelist)` If specified the open files are associated with the specified pending changelist number; otherwise the open files are associated with the default changelist.
`void` `setCommandlength(int len)` Set the maximum length of the commandline when calling Perforce to add the files.

Methods inherited from class org.apache.tools.ant.taskdefs.optional.perforce.P4Base
`execP4Command, execP4Command, getErrorMessage, getInError, init, setClient, setCmdopts, setErrorMessage, setFailonerror, setGlobalopts, setInError, setPort, setUser, setView`

Methods inherited from class org.apache.tools.ant.Task
`bindToOwner, getOwningTarget, getRuntimeConfigurableWrapper, getTaskName, getTaskType, getWrapper, handleErrorFlush, handleErrorOutput, handleFlush, handleInput, handleOutput, isInvalid, log, log, log, log, maybeConfigure, perform, reconfigure, setOwningTarget, setRuntimeConfigurableWrapper, setTaskName, setTaskType`

Methods inherited from class org.apache.tools.ant.ProjectComponent
`clone, getDescription, getLocation, getProject, setDescription, setLocation, setProject`

Methods inherited from class java.lang.Object
`equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### P4Add

    public P4Add()

Method Detail

### setCommandlength

    public void setCommandlength(int len)
                          throws BuildException

  Set the maximum length of the commandline when calling Perforce to add the files. Defaults to 450, higher values mean faster execution, but also possible failures.

  Parameters:
    `len` - maximum length of command line default is 450.
  Throws:
    `BuildException` - if trying to set the command line length to 0 or less.

### setChangelist

    public void setChangelist(int changelist)
                       throws BuildException

  If specified the open files are associated with the specified pending changelist number; otherwise the open files are associated with the default changelist.

  Parameters:
    `changelist` - the change list number.
  Throws:
    `BuildException` - if trying to set a change list number <=0.

### addFileset

    public void addFileset(FileSet set)

  Add a fileset whose files will be added to Perforce.

  Parameters:
    `set` - the FileSet that one wants to add to Perforce Source Control.

### execute

    public void execute()
                 throws BuildException

  Run the task.

  Overrides:
    `execute` in class `Task`
  Throws:
    `BuildException` - if the execution of the Perforce command fails.